/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.test;

import java.util.Date;
import java.util.EventListener;
import java.util.EventObject;
import java.util.UUID;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.SessionScoped;
import org.ajax4jsf.event.PushEventListener;


@ManagedBean(name = "pushBean")
@SessionScoped
public class PushBean implements Runnable {


    private String uuid = "";
    private boolean enabled = false;
    private Date startDate;
    PushEventListener listener;
    private Thread thread;

    public void addListener(EventListener listener) {
        synchronized (listener) {
            if (this.listener != listener) {
                System.out.println("Listener added....");
                this.listener = (PushEventListener) listener;
            }
        }
    }

    public void run() {
        while (thread != null) {
            System.out.println("Running....");
            try {
                if (((new Date()).getTime() - startDate.getTime()) >= 60000) {
                    stop();
                }
                uuid = UUID.randomUUID().toString();
                System.out.println("Invoking for rendering...."+uuid);
                this.listener.onEvent(new EventObject(this));
                Thread.sleep(10000);
            } catch (InterruptedException e) {
                // TODO Auto-generated catch block

            }
        }
    }

    public String getUuid() {
        System.out.println("Fetching UUID...."+uuid);
        return uuid;
    }

    public void start() {
        if (thread == null) {
            thread = new Thread(this);
            thread.setDaemon(true);
            thread.start();
            setStartDate(new Date());
            setEnabled(true);
        }
    }

    public void stop() {
        if (thread != null) {
            setStartDate(null);
            setEnabled(false);
            thread = null;
        }
    }

    public Thread getThread() {
        return thread;
    }

    public boolean isEnabled() {
        return enabled;
    }

    public void setEnabled(boolean enabled) {
        this.enabled = enabled;
    }

    public Date getStartDate() {
        return startDate;
    }

    public void setStartDate(Date startDate) {
        this.startDate = startDate;
    }
}
